<?php
/*
*
* @package Bookmarks on Index
* @author Lehrling (forumstyling.bplaced.net)
* @copyright (c) 2018 by Lehrling (forumstyling.bplaced.net)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
* 
*/

namespace lehrling\bookmarks_on_index\event;

/**
* @ignore
*/
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class listener implements EventSubscriberInterface
{
   /** @var string phpBB root path */
   protected $root_path;

   /** @var string PHP extension */
   protected $php_ext;

   /** @var \phpbb\config\config */
   protected $config;

   /** @var \phpbb\template\template */
   protected $template;

   /** @var \phpbb\user */
   protected $user;

   /**
   * Constructor
   *
   * @param \phpbb\config\config               $config               Config object
   * @param \phpbb\template\template            $template            Template object
   * @param \phpbb\user                     $user               User object
   */
   public function __construct($root_path, $php_ext, \phpbb\config\config $config, \phpbb\template\template $template, \phpbb\user $user)
   {
      $this->root_path   = $root_path;
      $this->php_ext      = $php_ext;
      $this->config      = $config;
      $this->template      = $template;
      $this->user         = $user;
   }

   static public function getSubscribedEvents()
   {
      return array(
         'core.user_setup'            => 'load_language_on_setup',
         'core.page_header_after'      => 'add_bookmark_link',
      );
   }

   public function load_language_on_setup($event)
   {
      $lang_set_ext = $event['lang_set_ext'];
      $lang_set_ext[] = array(
         'ext_name'      => 'lehrling/bookmarks_on_index',
         'lang_set'      => 'bookmarks_on_index',
      );
      $event['lang_set_ext'] = $lang_set_ext;
   }

   public function add_bookmark_link($event)
   {
      $this->template->assign_vars(array(
         'U_UM_BOOKMARKS'   => ($this->config['allow_bookmarks']) ? append_sid("{$this->root_path}ucp.{$this->php_ext}", 'i=ucp_main&amp;mode=bookmarks') : '',
      ));
   }
}